<?php

namespace App\Http\Controllers\admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Adminlogin;
use DB;
use App\Users;
//use App\Faqs;
//use App\Hospitaluser;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Contracts\Encryption\DecryptException;
use App\Category;
//use App\Sub_cat;
use App\Subcategory;
//use App\Admincontacts;

class AdminController extends Controller
{
  public function __construct()
  {
    DB::enableQueryLog();
  }
  public function CommonAed(Request $request,$userId,$status,$callback,$tablename)
  {
         try {
          //echo $tablename;die;
            $id = Crypt::decryptString($userId);
            $status = Crypt::decryptString($status);
            $tablename = Crypt::decryptString($tablename);
         } catch (DecryptException $e) {
            $message = trans('messages.invalid_info');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
            return redirect('admin/dashboard');
         }
         if($status != 0 && $status != 1 && $status != 2 && $status != 3)
         {
            $message = trans('messages.invalid_info');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
            return redirect("admin/".$callback);
         } 

         #echo $tablename;die;
         $result = DB::table($tablename)->where("id",$id)->count();
         
         if($result)
         {

            $update_array = array("status" => $status);
            $response = DB::table($tablename)->where("id",$id)->update($update_array);
            if($response == 1)
            {
               if($tablename == 'Users')
               {
                  /*$user_obj = new Users();
                  $userInfo = $user_obj->select('loginType','userName','email')->where('id',$id)->first();
                  $userType = $userInfo['loginType'];*/
                  
                   
                     /*$mailMsg = '';$mailSubject = '';
                     if($status == 1){ //Approve
                        $mailMsg = trans('messages.Your account has been unarroved');
                        $mailSubject = trans('messages.Account Unapproved');
                     }elseif($status == 2){  //Unapprove
                        $mailMsg = trans('messages.Your account has been arroved');
                        $mailSubject = trans('messages.Account Approved');   
                     }

                      
                     $objDemo = new \stdClass();
                     $objDemo->invoice_file = '';
                     $objDemo->sender = 'SwissExpress';
                     $objDemo->receiver = $userInfo['userName'];
                     $objDemo->from = env( 'MAIL_USERNAME' );
                     $objDemo->subject = $mailSubject;
                     $objDemo->message = $mailMsg;
                     $objDemo->view_file = 'emailtemplate.company_account_status';
                     Mail::to($userInfo['email'])->send(new DemoEmail($objDemo)); */
                       
                  
               }

               if($tablename == 'drivers'){
                  /*$driver_obj = new Drivers();
                  $driverInfo = $driver_obj->select('fullname','email')->where('id',$id)->first();*/
                  
                  /*$mailMsg = '';$mailSubject = '';
                  if($status == 1){ //Approve
                     $mailMsg = trans('messages.Your account has been unarroved');
                     $mailSubject = trans('messages.Account Unapproved');
                  }elseif($status == 2){  //Unapprove
                     $mailMsg = trans('messages.Your account has been arroved');
                     $mailSubject = trans('messages.Account Approved');   
                  }

                   
                  $objDemo = new \stdClass();
                  $objDemo->invoice_file = '';
                  $objDemo->sender = 'SwissExpress';
                  $objDemo->receiver = $driverInfo['fullname'];
                  $objDemo->from = env( 'MAIL_USERNAME' );
                  $objDemo->subject = $mailSubject;
                  $objDemo->message = $mailMsg;
                  $objDemo->view_file = 'emailtemplate.company_account_status';
                  Mail::to($driverInfo['email'])->send(new DemoEmail($objDemo));*/ 
                    
                  
               }

               $messages = trans('messages.Record updated successfully');
               $request->session()->flash("message","<div class='alert alert-success'><strong>".$messages.".</strong></div>");
            }else{
               $messages = trans('messages.went_wrong');
               $request->session()->flash("message","<div class='alert alert-danger'><strong>".$messages."</strong></div>");
          }
         }else{
            $messages = trans('messages.This record is not exist');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$messages.".</strong></div>");
         }  
         return redirect("admin/".$callback);      
   }
    public function login(Request $request)
    {
  		$data['heading'] = trans('messages.Admin Login');
 			return view("admin.login")->with(array("data"=> $data));
    }
    public function LoginSubmit(Request $request){
   	$messages = [
         'username.required' => trans('validation.required'),
         'password.required' => trans('validation.required')
     	];
      $validatedData = $request->validate([
            'username' => 'required',
            'password' => 'required'
     	],$messages);

   	$admin_obj = new Adminlogin();
    	$result = $admin_obj->where("username" , $request->username)
    				->where("password" , md5($request->password))->first();

      $query = DB::getQueryLog();
      
      if(!empty($result))
     	{
     		session(["id" => $result->id,"login_type"=>"Admin"]);
    		$message =  trans('messages.login_successfully');
    		$request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
        	return redirect("admin/dashboard");
		}else{
        	$message =  trans('messages.email_pass_not_match');
        	$request->session()->flash("message","<div class='alert  alert-danger'><strong>".$message.".</strong></div>");
        	return redirect("login")->withInput();
     	}  
   }
   public function dashboard(Request $request)
   {
   		$data['heading'] = trans('messages.Admin Dashboard');
      	return view("admin.dashboard")->with(array("data"=> $data));
   }
   public function editCatSubmit(Request $request)
   {
      $all_var = $request->all();
      $Category_obj = new Category();
      $response = $Category_obj->update_record($all_var);
      if($response == 1)
      {
        $message =  trans('messages.Record updated successfully');
        $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
      }else{
        $message =  trans('messages.went_wrong');
        $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect("admin/listCategory");
   }
   public function addSubCatSubmit(SubCatValidation $request)
   {
      $all_var = $request->all();
      $Sub_cat_obj = new Sub_cat();
      $insert_array = array("sub_category_name"=>$all_var["sub_category_name"]);
      $response = $Sub_cat_obj->insert_record($insert_array);
      if($response == 1)
      {
        $message =  trans('messages.Sub Category added successfully');
        $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
      }else{
        $message =  trans('messages.went_wrong');
        $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect("admin/addSubCategory");
   }
   public function editSubCatSubmit(ESubCatValidation $request)
   {
      $update_array = array("sub_category_name"=>$request->sub_category_name);
      $where = array("id"=>$request->id);
      $Sub_cat_obj = new Sub_cat();
      $response = $Sub_cat_obj->update_record($update_array,$where);
      if($response == 1)
      {
        $message =  trans('messages.Record updated successfully');
        $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
      }else{
        $message =  trans('messages.went_wrong');
        $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect("admin/listSubCategory");
    }
}
